using System;
using RomeScriptInterfaces;
using Scripts;

namespace Scripts
{
    [Serializable]
    public class ArabianBizarreHard : ScriptServer.IScript
    {
        
        // for our messaging
        private String msgTitle, msgText, msgWarn;
        private String msgSound = "message1.mp3";
        private String msgApplause = "/../../sounds/events/event_circus_01.wav";
        private String msgRiot = "/../../sounds/events/event_coliseum_05.wav";
        private String msgMummy = "/../../sounds/buildings/obelisk_04.wav";
        private String msgNoSound = "";
        
        // variables for current ratings
        private uint nFavor, nSecurity, nCulture, nProsperity, nBeauty, uBeauty;
        private uint uDes, uUndes, uGovBR, uRelBR, uPatBR, uEntBR, uOtherBR, uSmallST, uMediumST, uLargeST, uTree1, uTree2, uBush, uGarden, uDeco, uTHB;
        private uint oldFavor = 55;
        private Int32 nPopulation, nCityFunds, nSavings;
        private Int32 eFavor, eSecurity, eCulture, eProsperity, eBeauty, eCityFunds, eSavings, eScore;
        // version specific targets
        private Int32 tPopulation = 8000;
        private uint tSand = 64;
        private uint tGlass = 32;
        private uint tMummy = 16;
        private Int32 tDefeat = -2500;

        // flags to tell us whether specific events have happened
        private bool bInit = false;
        private bool bScored = false;
        private bool bObelisk = false;
        private bool bMummy = false;
        private bool bTree = false;
        private bool bStatue2 = false;
        private bool bStatue3 = false;
        private bool bMessageSent = false;
        private bool bPatricians = false;
        private bool bAlly = false;             // a tribute to the mad tester from the mad designer
        private bool bHiero = false;            // a tribute to the mad designer from the mad tester
        private bool bTheater = false;
        private bool bArena = false;
        private bool bColiseum = false;
        private bool bCircus = false;
        private bool bHospital = false;
        private bool bBasilica = false;
        private bool[] bEmptyVenue = { false, false, false, false };

        // trade variables
        private bool[] bTrade = { false, false, false, false, false, false, false, false, false, false, false, false };
        private bool[] bRenew = { false, false, false, false, false, false, false, false, false, false, false, false };
        private bool bTradeFixed = false;
        private bool bGlass = true;
        private uint nTradeCheck = 0;
        private uint kLatium = 0;
        private uint kTarraco = 1;
        private uint kHispania = 2;
        private uint kLugdunum = 3;
        private uint kAchaea = 4;
        private uint kAsia = 5;
        private uint kAegyptus = 6;
        private uint kAfrica = 7;
        private uint kNumidia = 8;
        private uint kMesopotamia = 9;
        private uint kYemen = 10;
        private uint kIllyricum = 11;
        private uint kEpirus = 12;
        private uint kRaetia = 13;
        private uint kDefeat = 16;
        private uint nOpen = 0;
        private uint tAllTrade = 0;
        private uint tPerfectBeauty = 0;
        private uint nTradeWarn = 0;

        private String[] sTrade = { "Latium", "Tarraco", "Hispania", "Lugdunum", "Achaea", "Asia", "Aegyptus", "Africa", "Numidia", "Mesopotamia", "Yemen", "Illyricum" };
        private String[] sRating = { "Favor", "Security", "Culture", "Prosperity", "Beauty", "Population", "Treasury", "Savings", "Temple", "Circus", "Military", "Glass" };
        private uint kProsperity, kCulture, kSecurity, kBeauty, kPopulation, kTemples, kCircus, kTreasury, kSavings, kMilitary;

        // variables for different checks
        private uint nTime = 0;                    // derived from game.GameTime
        private uint[] nTimerCheck = { 15, 890, 1850, 2810, 3770, 4730, 5690, 6170, 6650, 7130, 7370, 7450, 7530, 7610, 999999 };
        private String[] sTimeLeft = { "96", "84", "72", "60", "48", "36", "24", "18", "12", "6", "3", "2", "1", "0", "X" };
        private uint iMessage = 0;
        private uint nWageCheck = 960;             // check after a year
        private uint nPayCheck = 0;
        private uint nBeautyCheck = 18;            // every week, just before its end
        private uint nBeautyTip = 1080;            // first tip at start of March 2nd year
        private uint nPatricianTip = 480;          // after 6 months
        private uint nDecoServ = 320;              // first after 4 months
        private uint nSnowCheck = 565;
        private uint nMummyCheck = 2160;
        private uint nCommodusCheck = 20;
        private uint nCommodus = 1;
        private uint nComObelisk = 0;
        private uint nComBeauty = 0;
        private uint nMaxSheep = 0;
        private uint iMummy = 0;
        private uint nMummy = 1;
        private uint xMummy = 0;
        private uint nEasterEgg = 240;
        private uint nTwoWeeks = 40;
        private uint nMonth = 80;
        private uint noCircus = 0;                 // number of "ticks" with an inactive circus
        
        // variables for wage and population checks
        private Int32 nWageTrigger = 10000;        // first raise when city funds reach this level
        private int nPlebWages = 16;               // starting wages for plebs
        private int nEquiteWages = 24;             // ...and equites

        // resource IDs
        private Int32 mIDSand = IDMaker.FromString("C4cr Sand");
        private Int32 mIDGlassware = IDMaker.FromString("C4cr Glass");
        private Int32 mIDSilk = IDMaker.FromString("C4cr Silk");
        private Int32 mIDIncense = IDMaker.FromString("C4cr Incense");
        private Int32 mBlizzard = IDMaker.FromString("BLIZZARD");

        // building IDs
        private Int32 mIDPalace1 = IDMaker.FromString("C4b Governor's Palace Small");
        private Int32 mIDPalace2 = IDMaker.FromString("C4b Governor's Palace Medium");
        private Int32 mIDPalace3 = IDMaker.FromString("C4b Governor's Palace Large");
        private Int32 mIDTaxOffice = IDMaker.FromString("C4b Office Tax Collector");
        
        private Int32 mIDDomus1 = IDMaker.FromString("C4b Equites Housing 01");
        private Int32 mIDDomus2 = IDMaker.FromString("C4b Equites Housing 02");
        private Int32 mIDDomus3 = IDMaker.FromString("C4b Equites Housing 03");
        private Int32 mIDInsula1 = IDMaker.FromString("C4b Plebian home 01");
        private Int32 mIDInsula2 = IDMaker.FromString("C4b Plebian home 02");
        private Int32 mIDInsula3 = IDMaker.FromString("C4b Plebian home 03");
        private Int32 mIDForum = IDMaker.FromString("C4b service Forum");
        private Int32 mIDBasilica = IDMaker.FromString("C4b service Basilica");
        private string[] sPatricians = {"C4b Patrician home 01","C4b Patrician home 02","C4b Patrician home 03",
             "C4b Patrician home 04","C4b Patrician home 05","C4b Patrician home 06","C4b Patrician home 07",
             "C4b Patrician home 08","C4b Patrician home 09"};

        private Int32 mIDCattleFarm = IDMaker.FromString("C4b harvester Livestock farmer's house");
        private Int32 mIDSheepFarm = IDMaker.FromString("C4b harvester Wool farmer's house");
        private Int32 mIDSheepPasture = IDMaker.FromString("c4r Sheep Pasture");
        private Int32 mIDSandCamp = IDMaker.FromString("C4b harvester Sand collector's house");
        private Int32 mIDIronMine = IDMaker.FromString("C4b harvester Iron miners house");
        private Int32 mIDGoldMine = IDMaker.FromString("C4b harvester Gold miners house");
        private Int32 mIDMarbleCamp = IDMaker.FromString("C4b harvester Marble collector's camp");
        private Int32 mIDGlass = IDMaker.FromString("C4b factory Glass");
        private Int32 mIDJewelry = IDMaker.FromString("C4b factory Jewelry");
        private Int32 mIDArmor = IDMaker.FromString("C4b factory Armor");
        private Int32 mIDWeapons = IDMaker.FromString("C4b factory Weapons");
        //
        private Int32 mIDLuxury = IDMaker.FromString("C4b Market Luxury");
        private Int32 mIDExotic = IDMaker.FromString("C4b Market Exotic");
        private Int32 mIDGranary = IDMaker.FromString("C4b infra Granary");
        private Int32 mIDWarehouse = IDMaker.FromString("C4b infra Warehouse");
        private Int32 mIDDepot = IDMaker.FromString("C4b Depot");
        private Int32 mIDPort = IDMaker.FromString("C4b Depot with Dock");
        //
        private Int32 mIDFountain = IDMaker.FromString("C4b infra Fountain");
        private Int32 mIDBathhouse = IDMaker.FromString("C4b service Bathhouse");
        private Int32 mIDHospital = IDMaker.FromString("C4b service Hospital");
        private Int32 mIDLibrary = IDMaker.FromString("C4b service Library");
        //
        private Int32 mIDJupiterTemple = IDMaker.FromString("C4b Service Temple Jupiter");
        private Int32 mIDCeresTemple = IDMaker.FromString("C4b Service Temple Ceres");
        private Int32 mIDMarsTemple = IDMaker.FromString("C4b Service Temple Mars");
        private Int32 mIDBacchusTemple = IDMaker.FromString("C4b Service Temple Bacchus");
        private Int32 mIDMercuryTemple = IDMaker.FromString("C4b Service Temple Mercury");
        private Int32 mIDJupiterShrine = IDMaker.FromString("C4b Service Shrine Jupiter");
        private Int32 mIDCeresShrine = IDMaker.FromString("C4b Service Shrine Ceres");
        private Int32 mIDMarsShrine = IDMaker.FromString("C4b Service Shrine Mars");
        private Int32 mIDBacchusShrine = IDMaker.FromString("C4b Service Shrine Bacchus");
        private Int32 mIDMercuryShrine = IDMaker.FromString("C4b Service Shrine Mercury");
        //
        private Int32 mIDOdeum = IDMaker.FromString("C4b service Odeum");
        private Int32 mIDTheater = IDMaker.FromString("C4b service Theater");
        private Int32 mIDArena = IDMaker.FromString("C4b service Arena");
        private Int32 mIDColiseum = IDMaker.FromString("C4b service Coliseum");
        private Int32 mIDCircus = IDMaker.FromString("C4b service Circus");
        private Int32 mIDActor = IDMaker.FromString("C4b Training Actor");
        private Int32 mIDGladiator = IDMaker.FromString("C4b Training Gladiator");
        //
        private Int32 mIDCavFort = IDMaker.FromString("C4b Mil Fort Auxilia Cavalry");
        private Int32 mIDDrillYard = IDMaker.FromString("C4b Mil Drill Yard");
        private Int32 mIDArmory = IDMaker.FromString("C4b Mil Armory");
        private Int32 mIDMessHall = IDMaker.FromString("C4b Mil Mess Hall");
        // 
        private Int32 mIDGarden = IDMaker.FromString("C4 Deco Garden");
        private Int32 mIDHedgeSmall = IDMaker.FromString("C4 Deco Hedge Small");
        private Int32 mIDHedgeLarge = IDMaker.FromString("C4 Deco Hedge Large");
        private Int32 mIDBushSmall = IDMaker.FromString("C4 Deco Bush Small");
        private Int32 mIDBushLarge = IDMaker.FromString("C4 Deco Bush Large");
        private Int32 mIDTreeSmall = IDMaker.FromString("C4 Deco Tree Small");
        private Int32 mIDTreeMedium = IDMaker.FromString("C4 Deco Tree Medium");
        private Int32 mIDTreeLarge = IDMaker.FromString("C4 Deco Tree Large");
        private Int32 mIDHedgeRowSmall = IDMaker.FromString("C4 Deco HedgeRow Small");
        private Int32 mIDHedgeRowLarge = IDMaker.FromString("C4 Deco HedgeRow Large");
        private Int32 mIDStatue1 = IDMaker.FromString("C4 Deco Statue 1");
        private Int32 mIDStatue2 = IDMaker.FromString("C4 Deco Statue 2");
        private Int32 mIDStatue3 = IDMaker.FromString("C4 Deco Statue 3");
        private Int32 mIDStatue4 = IDMaker.FromString("C4 Deco Statue 4");
        private Int32 mIDStatue5 = IDMaker.FromString("C4 Deco Statue 5");
        private Int32 mIDStatue6 = IDMaker.FromString("C4 Deco Statue 6");
        private Int32 mIDObelisk = IDMaker.FromString("C4b Statue Obelisk");

        // build button IDs
        private Int32 mUIIDSafety = IDMaker.FromString("SAFETY");
        private Int32 mUIIDPatHome = IDMaker.FromString("PAT_HOME");
        private Int32 mUIIDExoticMarket = IDMaker.FromString("MARKET_EXOTIC");
        private Int32 mUIIDObelisk = IDMaker.FromString("PRESALE1");
        private Int32 mUIIDWinged = -997158636;
        private Int32 mUIIDChariot = -1047491516;
        private Int32 mUIIDHuntsman = IDMaker.FromString("STATUE3");
        private Int32 mUIIDHorseman = IDMaker.FromString("STATUE4");
        private Int32 mUIIDSmallTree = IDMaker.FromString("DECO6");
        private Int32 mUIIDMediumTree = IDMaker.FromString("DECO3");
        private Int32 mUIIDLargeTree = IDMaker.FromString("DECO5");
        private Int32 mUIIDOdeum = 1740942627;
        private Int32 mUIIDTheater = -137606214;
        private Int32 mUIIDActor = 1806783073;
        private Int32 mUIIDArena = 1724165050;
        private Int32 mUIIDGladiator = 1806783075;
        private Int32 mUIIDColiseum = 1691448420;
        private Int32 mUIIDCircus = -2046596977;
        private Int32 mUIIDHospital = -1282219393;
        private Int32 mUIIDBasilica = 276325373;
        private Int32 mUIIDDepot0 = IDMaker.FromString("Depot0");
        private Int32 mUIIDDepot1 = IDMaker.FromString("Depot1");
        private Int32 mUIIDDepot2 = IDMaker.FromString("Depot2");
        private Int32 mUIIDDepot3 = IDMaker.FromString("Depot3");
        private Int32 mUIIDDepot4 = IDMaker.FromString("Depot4");

        // The following declarations are necessary as this scenario uses custom standward wage changes
        private StandardWageManager mWageManagerPlebe = null;
        private StandardWageManager mWageManagerEques = null;

        private TMilitaryAI mMilitaryAI = null;
        private InvasionSetup[] mInvasions;

        // This is the main script loop
        public void Run(object gameInterface)
        {
            IGameQueryInterface gameQueryInterface = (IGameQueryInterface)gameInterface;
            switch (gameQueryInterface.RunReason)
            {
                case RunReason.kTick:
                    OnTick(gameQueryInterface);
                    break;

                case RunReason.kOnBeginScenario:
                    OnBeginScenario(gameQueryInterface);
                    break;

                case RunReason.kOnInvasionArrival:
                    OnInvasionArrival(gameQueryInterface);
                    break;

                case RunReason.kOnCohortTargetDestroyed:
                    OnCohortTargetDestroyed(gameQueryInterface);
                    break;

                case RunReason.kOnLoadScenario:
                    OnScenarioLoad(gameQueryInterface);
                    break;
            }
        }

        void OnTick(IGameQueryInterface game)
        {
            if (bInit)
            {
                bInit = false;
                ResetBaseUI(game);
            }

            // Set our city ratings
            GetCityRatings(game);

            if (!bMessageSent && (nTime > nTimerCheck[iMessage])) TimerMessage(game);

            // check trade status
            if (nTime > nTradeCheck) CheckTrade(game);
            if (!bMessageSent && !bTrade[kMilitary]) CheckMilitaryTrade(game);
            if (!bMessageSent && !bAlly && (nTime > nEasterEgg)) EasterEgg(game);

            UpdateTradeState(game);

            // check to see if player is paying more than the rank justifies
            if (!bMessageSent && (nTime > nPayCheck)) SalaryCheck(game);

            // check mummy rampage
            if (!bMessageSent && bObelisk && (nTime > nMummyCheck)) CheckMummy(game);
           
            if (!bMessageSent && (nTime > nCommodusCheck)) CommodusStory(game);
            
            // can we unlock anything based on trade?
            if (!bMessageSent && (nTime > nDecoServ)) CheckDecoService(game);

            // are wage expectations raised?
            if (!bMessageSent && (nTime > nWageCheck)) CheckWageExpectations(game);

            // enable Patricians yet?
            if (!bPatricians) CheckPatricians(game);

            if (nTime > nSnowCheck)
            {
                game.TriggerWeatherEffect(mBlizzard);
                nSnowCheck += 960;
            }

            mMilitaryAI.Update(game, 0.1);
        }

        ////////////////////////////////////////////////
        // This is where we get the city ratings etc
        void GetCityRatings(IGameQueryInterface game)
        {
            bMessageSent = false;
            nTime = game.GameTime / 1000;           // time measured in seconds
            game.GetFavorRating(out nFavor);
            game.GetSecurityRating(out nSecurity);
            game.GetProsperityRating(out nProsperity);
            game.GetCultureRating(out nCulture);
            game.GetPopulation(out nPopulation);
            game.GetGovernorPersonalFunds(out nSavings);
            game.GetCityFunds(out nCityFunds);
            
            // check for defeat trigger
            if (nCityFunds <= tDefeat)
            {
                game.OpenTradeRoute(kDefeat);
                game.ScriptDone = true;   
            }

            if (nTime > nBeautyCheck) ShowBeautyRating(game);
            // check for perfect beauty
            if ((tPerfectBeauty == 0) && (nBeauty > 99) && (nPopulation >= tPopulation))
            {
                tPerfectBeauty = nTime;
                msgTitle = "Perfect_Beauty_Title";
                msgText = "Perfect_Beauty_Text";
                GiveAcclamation(game);
            }

            // set the victory flag when time is up and calculate the score
            if (nTime >= 7640)
            {
                game.ScriptDone = true;
                if (!bScored)
                {
                    eBeauty = (Int32)nBeauty;
                    eCulture = (Int32)nCulture;
                    eFavor = (Int32)nFavor;
                    eProsperity = (Int32)nProsperity;
                    eSecurity = (Int32)nSecurity;
                    eCityFunds = Math.Min(nCityFunds, 25000);
                    eSavings = nSavings;
                    eScore = 25 * (eBeauty + eCulture + eFavor + eProsperity + eSecurity) + eSavings + eCityFunds / 10;
                    bScored = true;
                }
            }
        }

        //////////////////////////////////////////////////////
        // set or reset who requires what
        // favor,security,culture,prosperity,beauty,population,
        // treasury,savings,temples,circus,military
        void SetTradeCriteria(IGameQueryInterface game)
        {
            Random nRand = new Random((int)game.GameTime);
            Int32 iOption = nRand.Next(1, 11);
            uint[] uCriteria;

            if (iOption == 1) 
                uCriteria = new uint[] { 0, 6, 5, 9, 10, 2, 7, 3, 1, 4, 8 };
            else if (iOption == 2)
                uCriteria = new uint[] { 0, 5, 10, 6, 9, 1, 8, 2, 4, 3, 7 };
            else if (iOption == 3)
                uCriteria = new uint[] { 0, 10, 9, 6, 5, 4, 7, 1, 3, 2, 8 };
            else if (iOption == 4)
                uCriteria = new uint[] { 0, 5, 6, 10, 9, 3, 8, 4, 2, 1, 7 };
            else if (iOption == 5)
                uCriteria = new uint[] { 0, 6, 5, 9, 10, 2, 7, 4, 3, 1, 8 };
            else if (iOption == 6)
                uCriteria = new uint[] { 0, 9, 5, 6, 10, 1, 8, 3, 2, 4, 7 };
            else if (iOption == 7)
                uCriteria = new uint[] { 0, 9, 5, 10, 6, 4, 7, 2, 1, 3, 8 };
            else if (iOption == 8)
                uCriteria = new uint[] { 0, 9, 6, 5, 10, 3, 8, 1, 4, 2, 7 };
            else if (iOption == 9)
                uCriteria = new uint[] { 0, 10, 6, 9, 5, 2, 7, 3, 1, 4, 8 };
            else if (iOption == 10)
                uCriteria = new uint[] { 0, 9, 10, 5, 6, 3, 8, 4, 2, 1, 7 };
            else
                uCriteria = new uint[] { 0, 6, 10, 5, 9, 1, 7, 3, 4, 2, 8 };

            // this sets up the cities against the 10 criteria (favor is always Latium)
            kSecurity = uCriteria[1];
            kCulture = uCriteria[2];
            kProsperity = uCriteria[3];
            kBeauty = uCriteria[4];
            kPopulation = uCriteria[5];
            kTreasury = uCriteria[6];
            kSavings = uCriteria[7];
            kTemples = uCriteria[8];
            kCircus = uCriteria[9];
            kMilitary = uCriteria[10];
            if (iOption < 7)
            {
                bGlass = false;
                sRating[11] = "Sand";
            }
            else
            {
                bGlass = true;
                sRating[11] = "Glass";
            }
        }

        /////////////////////////////////////////////////////////////////
        // Check if Raiders conquered - by detecting large favor increase
        void CheckMilitaryTrade(IGameQueryInterface game)
        {
            String invasion;
            bool bOpen = false;
            
            if (!bTrade[kMilitary])
            {
                game.GetIsTradeRouteOpen(kMilitary, out bOpen);
                if ((nFavor > (oldFavor + 20)) || (nFavor > 99))
                {
                    SetTradeOpen(game, kMilitary, 10);
                    invasion = "raid0";
                    game.StopInvasion(ref invasion, true);
                    invasion = "raid1";
                    game.StopInvasion(ref invasion, true);
                    game.ClearInvasions();
                }
                else if (bOpen)
                    SetTradeClosedP(game, kMilitary, 10);
            }
            oldFavor = nFavor;
        }

        ///////////////////////////////////////////
        // Check if Circus Trade Route open
        void CheckCircusTrade(IGameQueryInterface game)
        {
            uint numA, numT;
            game.GetActiveBuildings(mIDCircus, out numA);
            game.GetTotalBuildings(mIDCircus, out numT);

            bool bOpen = false;
            game.GetIsTradeRouteOpen(kCircus, out bOpen);
            if (!bTrade[kCircus] && (numA > 0))
                SetTradeOpen(game, kCircus, 9);
            else if (bTrade[kCircus] && (numT == 0))
                SetTradeClosed(game, kCircus, 9);
            else if (!bTrade[kCircus] && bOpen)
                SetTradeClosedP(game, kCircus, 9);
        }

        ///////////////////////////////////////////
        // Check if Temple Trade Route open
        void CheckTempleTrade(IGameQueryInterface game)
        {
            uint nCeres, nJupiter, nBacchus, nMercury, nMars, num;
            game.GetActiveBuildings(mIDJupiterTemple, out nJupiter);
            game.GetActiveBuildings(mIDCeresTemple, out nCeres);
            game.GetActiveBuildings(mIDBacchusTemple, out nBacchus);
            game.GetActiveBuildings(mIDMercuryTemple, out nMercury);
            game.GetActiveBuildings(mIDMarsTemple, out nMars);

            num = nCeres * nJupiter * nBacchus * nMercury * nMars;

            bool bOpen = false;
            game.GetIsTradeRouteOpen(kTemples, out bOpen);

            if (!bTrade[kTemples] && (num > 0))
                SetTradeOpen(game, kTemples, 8);
            else if (bTrade[kTemples] && (num == 0))
                SetTradeClosed(game, kTemples, 8);
            else if (!bTrade[kTemples] && bOpen)
                SetTradeClosedP(game, kTemples, 8);
        }
        
        ///////////////////////////////////////////////////////////////////////////////////////
        // Unlock trading based on ratings: favor,security,culture,prosperity,beauty
        void CheckRatingTrade(IGameQueryInterface game, uint iTrade, int iRating, uint nRating)
        {
            bool bOpen = false;
            game.GetIsTradeRouteOpen(iTrade, out bOpen);
            if (!bTrade[iTrade] && (nRating >= 67))
                SetTradeOpen(game, iTrade, iRating);
            else if (bTrade[iTrade] && (nRating < 62))
                SetTradeClosed(game, iTrade, iRating);
            else if (bOpen && !bTrade[iTrade])
                SetTradeClosedP(game, iTrade, iRating);
        }

        /////////////////////////////////////////////////////////
        // Check if Population/Treasury/Savings trade route open
        void CheckStatsTrade(IGameQueryInterface game, uint iTrade, int iStat, Int32 nStats)
        {
            Int32[] nTOpen = { 2670, 16700, 1670 };
            Int32[] nTClose = { 2400, 14000, 1400 };
            int i = iStat - 5;
            bool bOpen = false;
            game.GetIsTradeRouteOpen(iTrade, out bOpen);
            if (!bTrade[iTrade] && (nStats >= nTOpen[i]))
                SetTradeOpen(game, iTrade, iStat);
            else if (bTrade[iTrade] && (nStats < nTClose[i]))
                SetTradeClosed(game, iTrade, iStat);
            else if (!bTrade[iTrade] && bOpen)
                SetTradeClosedP(game, iTrade, iStat);
        }

        /////////////////////////////////////////////
        // Open or close trade based on Criteria
        void CheckTrade(IGameQueryInterface game)
        {
            if (!bTradeFixed) SetTradeCriteria(game);
            CheckRatingTrade(game, 0, 0, nFavor);
            if (!bMessageSent) CheckRatingTrade(game, kSecurity, 1, nSecurity);
            if (!bMessageSent) CheckRatingTrade(game, kCulture, 2, nCulture);
            if (!bMessageSent) CheckRatingTrade(game, kProsperity, 3, nProsperity);
            if (!bMessageSent) CheckRatingTrade(game, kBeauty, 4, nBeauty);
            if (!bMessageSent) CheckStatsTrade(game, kPopulation, 5, nPopulation);
            if (!bMessageSent) CheckStatsTrade(game, kTreasury, 6, nCityFunds);
            if (!bMessageSent) CheckStatsTrade(game, kSavings, 7, nSavings);
            if (!bMessageSent) CheckTempleTrade(game);
            if (!bMessageSent) CheckCircusTrade(game);
            if (!bMessageSent) CheckIllyricum(game);
            if (bMessageSent)
                nTradeCheck = nTime + 2;
            else
                nTradeCheck += 10;
        }

        /////////////////////////////////////////////////////////
        // Check if Illyricum trade route open
        void CheckIllyricum(IGameQueryInterface game)
        {
            bool bOpen = false;
            bool bMet = false;
            uint num = 0;
            if (bGlass)
            {
                game.GetResource(mIDGlassware, out num);
                if (num >= tGlass) bMet = true;
            }
            else
            {
                game.GetResource(mIDSand, out num);
                if (num >= tSand) bMet = true;
            }
            game.GetIsTradeRouteOpen(kIllyricum, out bOpen);
            if (!bTrade[kIllyricum])
            {
                if (bMet)
                    SetTradeOpen(game, kIllyricum, 11);
                else if (bOpen)
                    SetTradeClosedP(game, kIllyricum, 11);
            }
        }

        /////////////////////////////////////////////
        // Open trade route when criteria met
        void SetTradeOpen(IGameQueryInterface game, uint iTrade, int iCriterion)
        {
            game.OpenTradeRoute(iTrade);
            bTrade[iTrade] = true;
            game.UnlockUIControl(mUIIDDepot0, Toolset.MainGameFormID);
            if (bRenew[iTrade])
            {
                msgTitle = sTrade[iTrade] + "_R_Title";
                msgText = sTrade[iTrade] + "_" + sRating[iCriterion] + "_R_Text";
            }
            else
            {
                msgTitle = sTrade[iTrade] + "_O_Title";
                msgText = sTrade[iTrade] + "_" + sRating[iCriterion] + "_O_Text";
                nOpen++;
            }
            GiveAcclamation(game);
            if (iCriterion > 0) bTradeFixed = true;
        }

        //////////////////////////////////////////////////
        // Check all trade open, free slots if appropriate
        void UpdateTradeState(IGameQueryInterface game)
        {
            uint num, nSlots = 0;

            game.GetTotalBuildings(mIDDepot, out num);
            if (nOpen > num) nSlots = (uint)nOpen - num;
            if (nSlots > 0)
                game.UnlockUIControl(mUIIDDepot0, Toolset.MainGameFormID);
            else
                game.LockUIControl(mUIIDDepot0, Toolset.MainGameFormID);
            if (nSlots > 1)
                game.UnlockUIControl(mUIIDDepot1, Toolset.MainGameFormID);
            else
                game.LockUIControl(mUIIDDepot1, Toolset.MainGameFormID);
            if (nSlots > 2)
                game.UnlockUIControl(mUIIDDepot2, Toolset.MainGameFormID);
            else
                game.LockUIControl(mUIIDDepot2, Toolset.MainGameFormID);
            if (nSlots > 3)
                game.UnlockUIControl(mUIIDDepot3, Toolset.MainGameFormID);
            else
                game.LockUIControl(mUIIDDepot3, Toolset.MainGameFormID);
            if (nSlots > 4)
                game.UnlockUIControl(mUIIDDepot4, Toolset.MainGameFormID);
            else
                game.LockUIControl(mUIIDDepot4, Toolset.MainGameFormID);

            if ((num > nOpen) && (nTime > nTradeWarn))
            {
                msgTitle = "Trade_Warn_Title";
                msgText = "Trade_Warn_Text";
                DisplayMessage(game);
                nTradeWarn += 960;
            }

            // check for all trade open
            if (tAllTrade == 0)
            {
                if (nOpen > 13)
                {
                    tAllTrade = nTime;
                    msgTitle = "All_Trade_Title";
                    msgText = "All_Trade_Text";
                    GiveAcclamation(game);
                }
            }
        }

        ////////////////////////////////////////////////
        // Close trade route when criteria no longer met
        void SetTradeClosed(IGameQueryInterface game, uint iTrade, int iCriterion)
        {
            game.CloseTradeRoute(iTrade);
            bTrade[iTrade] = false;
            bRenew[iTrade] = true;
            msgTitle = sTrade[iTrade] + "_C_Title";
            msgText = sTrade[iTrade] + "_" + sRating[iCriterion] + "_C_Text";
            DisplayMessage(game);
        }

        /////////////////////////////////////////////
        // Close trade route when prematurely opened
        void SetTradeClosedP(IGameQueryInterface game, uint iTrade, int iCriterion)
        {
            game.CloseTradeRoute(iTrade);
            msgTitle = sTrade[iTrade] + "_C_Title";
            msgText = sTrade[iTrade] + "_" + sRating[iCriterion] + "_P_Text";
            DisplayMessage(game);
            if (iCriterion > 0) bTradeFixed = true;
        }

        ///////////////////////////////////////////
        // Check for the Ally Easter Egg!
        void EasterEgg(IGameQueryInterface game)
        {
            if (bTrade[kAsia] && bTrade[kLatium] && bTrade[kLugdunum] && bTrade[kYemen])
            {
                msgTitle = "Honey_Title";
                msgText = "Honey_Text";
                DisplayMessage(game);
                game.OpenTradeRoute(12);
                game.OpenTradeRoute(13);
                game.UnlockUIControl(mUIIDDepot0, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDDepot1, Toolset.MainGameFormID);
                nOpen += 2;
                bAlly = true;
            }
            nEasterEgg += 20;
        }
        
        ///////////////////////////////////////////
        // Check for an overpaid Governor
        void SalaryCheck(IGameQueryInterface game)
        {
            uint gRank, gSalary, num;
            game.GetGovernorRank(out gRank);
            game.GetGovernorSalaryLevel(out gSalary);
            if (gSalary > gRank)
            {
                msgTitle = "Tax_Riot_Title";
                msgText = "Tax_Riot_Text";
                DisplayRiot(game);
                game.GetTotalBuildings(mIDTaxOffice, out num);
                game.TriggerFireDamage(mIDTaxOffice, (int)num, 99);
                nPayCheck = nTime + 10;
            }
            nPayCheck += 10;
        }

        /////////////////////////////////////////////////////
        // Lock/Unlock decorative items based on trade opened 
        void CheckDecoService(IGameQueryInterface game)
        {
                    
            if (!bObelisk && (nOpen > 0))
            {
                bObelisk = true;
                game.UnlockUIControl(mUIIDObelisk, Toolset.MainGameFormID);
                msgTitle = "Obelisk_Title";
                msgText = "Obelisk_Text";
                DisplayMessage(game);
            }
            else if (!bTheater && (nOpen > 1) && (nCommodus < 6))
            {
                bTheater = true;
                game.UnlockUIControl(mUIIDTheater, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDActor, Toolset.MainGameFormID);
                msgWarn = "Theater_Open";
                DisplayWarning(game);
            }
            else if (!bTree && (nOpen > 2))
            {
                bTree = true;
                game.UnlockUIControl(mUIIDSmallTree, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDMediumTree, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDLargeTree, Toolset.MainGameFormID);
                msgWarn = "More_Deco";
                DisplayWarning(game);
            }
            else if (!bHospital && (nOpen > 3))
            {
                bHospital = true;
                game.UnlockUIControl(mUIIDHospital, Toolset.MainGameFormID);
                msgWarn = "Hospital_Open";
                DisplayWarning(game);
            }
            else if (!bStatue2 && (nOpen > 4))
            {
                bStatue2 = true;
                game.UnlockUIControl(mUIIDHuntsman, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDHorseman, Toolset.MainGameFormID);
                msgWarn = "More_Deco";
                DisplayWarning(game);
            }
            else if (!bArena && (nOpen > 5) && (nCommodus < 8))
            {
                bArena = true;
                game.UnlockUIControl(mUIIDArena, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDGladiator, Toolset.MainGameFormID);
                msgWarn = "Arena_Open";
                DisplayWarning(game);
            }
            else if (!bStatue3 && (nOpen > 6))
            {
                bStatue3 = true;
                game.UnlockUIControl(mUIIDChariot, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDWinged, Toolset.MainGameFormID);
                msgWarn = "More_Deco";
                DisplayWarning(game);
            }
            else if (!bColiseum && (nOpen > 7))
            {
                game.UnlockUIControl(mUIIDColiseum, Toolset.MainGameFormID);
                msgWarn = "Coliseum_Open";
                DisplayWarning(game);
                bColiseum = true;
            }
            else if (!bBasilica && (nOpen > 8))
            {
                bBasilica = true;
                game.UnlockUIControl(mUIIDBasilica, Toolset.MainGameFormID);
                msgWarn = "Basilica_Open";
                DisplayWarning(game);
            }
            else if (!bCircus && (nPopulation >= 4000))
            {
                bCircus = true;
                game.UnlockUIControl(mUIIDCircus, Toolset.MainGameFormID);
                msgWarn = "Circus_Open";
                DisplayWarning(game);
            }
            nDecoServ += 160;    // check again in 2 months time
        }

        ///////////////////////////////////////////
        // Release the Mummy!!!
        void CheckMummy(IGameQueryInterface game)
        {
            uint numS, numI, num;
            bool bSkip = false;
            if (!bMummy)
            {
                game.GetTotalBuildings(mIDObelisk, out num);
                if (num > 0) bMummy = true;
            }
            switch (nMummy)
            {
                case 1:
                    if (bMummy) DestroyMummyTarget(game);
                    if ((iMummy > 2) || !bMummy)
                    {
                        iMummy = 0;
                        nMummy++;
                        nMummyCheck = 3120;
                    }
                    break;

                case 2:
                    if (bMummy) DestroyMummyTarget(game);
                    if (iMummy == 1)
                        iMummy = 3;
                    else
                    {
                        xMummy = iMummy;
                        iMummy = 0;
                        nMummy++;
                        nMummyCheck = 4080;
                    }
                    break;

                case 3:
                    if (bTrade[kHispania] && bTrade[kIllyricum] && bAlly)
                        bHiero = true;
                    if (iMummy == 0) bSkip = true;
                    if (bHiero && bMummy)
                    {
                        game.GetResource(mIDSilk, out numS);
                        game.GetResource(mIDIncense, out numI);
                        if ((numS >= tMummy) && (numI >= tMummy) && (iMummy > 0))
                        {
                            nMummy++;
                            msgTitle = "Mummy_X_Title";
                            msgText = "Mummy_X_Text";
                            DisplayMessage(game);
                        }
                        else
                            DestroyMummyTarget(game);

                        if (bSkip) iMummy = xMummy;
                    }
                    else
                        nMummyCheck += 960;
                    break;

                case 4:
                    nMummyCheck += 9600;
                    break;

            }
        }

        //////////////////////////////////////////////////////
        // Mummy destruction!!!!  According to value of iMummy
        void DestroyMummyTarget(IGameQueryInterface game)
        {
            Int32 mIDt, mID = 0;
            uint num1, num2, num3, num = 0;

            if (iMummy == 0)
                mID = mIDObelisk;
            else if (iMummy == 1)
            {
                game.GetActiveBuildings(mIDInsula1, out num1);
                game.GetActiveBuildings(mIDInsula2, out num2);
                game.GetActiveBuildings(mIDInsula3, out num3);
                if (num3 > 0)
                    mID = mIDInsula3;
                else if (num2 > 0)
                    mID = mIDInsula2;
                else
                    mID = mIDInsula1;
            }
            else if (iMummy == 2)
            {
                game.GetActiveBuildings(mIDDomus1, out num1);
                game.GetActiveBuildings(mIDDomus2, out num2);
                game.GetActiveBuildings(mIDDomus3, out num3);
                if (num3 > 0)
                    mID = mIDDomus3;
                else if (num2 > 0)
                    mID = mIDDomus2;
                else
                    mID = mIDDomus1;
            }
            if (iMummy == 3)
            {
                game.GetTotalBuildings(mIDJupiterTemple, out num);
                if (num > 0)
                    mID = mIDJupiterTemple;
                else
                    iMummy++;
            }
            if (iMummy == 4)
            {
                game.GetTotalBuildings(mIDArena, out num);
                if (num > 0)
                    mID = mIDArena;
                else
                    iMummy++;
            }
            if (iMummy == 5)
            {
                game.GetTotalBuildings(mIDMarbleCamp, out num);
                if (num > 0)
                    mID = mIDMarbleCamp;
                else
                    iMummy++;
            }
            if (iMummy == 6)
            {
                game.GetTotalBuildings(mIDGoldMine, out num);
                if (num > 0)
                    mID = mIDGoldMine;
                else
                    iMummy++;
            }
            if (iMummy == 7)
            {
                game.GetTotalBuildings(mIDSandCamp, out num);
                if (num > 0)
                    mID = mIDSandCamp;
                else
                    iMummy++;
            }
            if (iMummy == 8)
            {
                game.GetTotalBuildings(mIDLuxury, out num);
                if (num > 0)
                    mID = mIDLuxury;
                else
                    iMummy++;
            }
            if (iMummy == 9)
            {
                game.GetTotalBuildings(mIDForum, out num);
                if (num > 0)
                    mID = mIDForum;
                else
                    iMummy++;
            }
            if (iMummy == 10)
            {
                game.GetTotalBuildings(mIDLibrary, out num);
                if (num > 0)
                    mID = mIDLibrary;
                else
                    iMummy++;
            }
            if (iMummy == 11)
            {
                game.GetTotalBuildings(mIDTaxOffice, out num);
                if (num > 0)
                    mID = mIDTaxOffice;
                else
                    iMummy++;
            }
            if (iMummy == 12)
            {
                game.GetTotalBuildings(mIDHospital, out num);
                if (num > 0)
                    mID = mIDHospital;
                else
                    iMummy++;
            }
            if (iMummy == 13)
            {
                num = nPalace(game);
                if (num == 1)
                    mID = mIDPalace1;
                else if (num == 3)
                    mID = mIDPalace2;
                else if (num == 5)
                    mID = mIDPalace3;
                else
                    iMummy++;
            }
            if (iMummy == 14)
            {
                for (int i = 0; i < 9; i++)
                {
                    mIDt = IDMaker.FromString(sPatricians[i]);
                    game.GetTotalBuildings(mID, out num);
                    if (num > 0) mID = mIDt;
                }
                if (mID == 0) iMummy = 1;
            }

            if (mID != 0)
            {
                msgTitle = "Mummy_" + iMummy.ToString() + "_Title";
                if (nMummy < 3)
                    msgText = "Mummy_" + iMummy.ToString() + "_Text";
                else
                    msgText = "Mummy_" + iMummy.ToString() + "_Text_S";
                DisplayMummyMsg(game);
                game.TriggerStructureDamage(mID, 1, 99);
            }
            if (iMummy > 14) iMummy = 1;
        }

        //////////////////////////////////////////////
        // Send 'mummy rampage' nessage to player
        void DisplayMummyMsg(IGameQueryInterface game)
        {
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgMummy);
            bMessageSent = true;
            iMummy++;
            nMummyCheck = nTime + 80;
        }

        //////////////////////////////////////////////
        // Send timer warning message
        void TimerMessage(IGameQueryInterface game)
        {
            msgWarn = sTimeLeft[iMessage] + "_Months_Left";
            DisplayWarning(game);
            iMessage++;
        }

        //////////////////////////////////////////////
        // Riotous happenings!
        void CommodusStory(IGameQueryInterface game)
        {
            uint num = 0;
            Int32 mID = 0;

            switch (nCommodus)
            {
                case 1:
                    msgTitle = "Crwal_Title";
                    msgText = "Crwal_Text";
                    DisplayMessage(game);
                    nCommodusCheck = 320;
                    nCommodus++;
                    break;

                case 2:
                    msgTitle = "Iopuk_Title";
                    msgText = "Iopuk_Text";
                    DisplayMessage(game);
                    nCommodusCheck = 1731;
                    nCommodus++;
                    break;

                case 3:
                    game.GetTotalBuildings(mIDObelisk, out num);
                    if ((num > 5) && (nBeauty < 40))
                    {
                        nComObelisk = num;
                        game.TriggerFireDamage(mIDObelisk, 1, 90);
                        msgTitle = "Obelisk_Fire_Title";
                        msgText = "Obelisk_Fire_Text";
                        DisplayMessage(game);
                        nCommodus++;
                        nCommodusCheck = nTime + 30;
                    }
                    else if (nTime > 3000)
                        nCommodus = 5;
                    else
                        nCommodusCheck += 80;
                    break;

                case 4:
                    game.GetTotalBuildings(mIDObelisk, out num);
                    if (num == nComObelisk)
                    {
                        msgTitle = "Obelisk_Safe_Title";
                        msgText = "Obelisk_Safe_Text";
                        DisplayMessage(game);
                    }
                    nCommodus++;
                    nCommodusCheck = nTime + 960;
                    break;

                case 5:
                    game.GetActiveBuildings(mIDActor, out num);
                    if ((num > 0) && (nBeauty < 55))
                    {
                        game.TriggerFireDamage(mIDActor, (int)num, 90);
                        game.LockUIControl(mUIIDActor, Toolset.MainGameFormID);
                        game.LockUIControl(mUIIDTheater, Toolset.MainGameFormID);
                        bTheater = false;
                        msgTitle = "Actor_Riot_Title";
                        msgText = "Actor_Riot_Text";
                        DisplayMessage(game);
                        nCommodus++;
                        nCommodusCheck = nTime + 240;
                        nComBeauty = nBeauty + 5;
                    }
                    else if (nTime > 4500)
                        nCommodus = 7;
                    else
                        nCommodusCheck = nTime + 80;
                    break;

                case 6:
                    if (nBeauty >= nComBeauty)
                    {
                        game.UnlockUIControl(mUIIDActor, Toolset.MainGameFormID);
                        game.UnlockUIControl(mUIIDTheater, Toolset.MainGameFormID);
                        bTheater = true;
                        msgTitle = "Actor_Return_Title";
                        msgText = "Actor_Return_Text";
                        DisplayMessage(game);
                        nCommodus++;
                        nCommodusCheck = 4500;
                    }
                    else
                        nCommodusCheck = nTime + 20;
                    break;

                case 7:
                    game.GetActiveBuildings(mIDGladiator, out num);
                    if ((num > 0) && (nBeauty < 70))
                    {
                        game.TriggerFireDamage(mIDGladiator, (int)num, 90);
                        game.LockUIControl(mUIIDArena, Toolset.MainGameFormID);
                        game.LockUIControl(mUIIDGladiator, Toolset.MainGameFormID);
                        bArena = false;
                        msgTitle = "Gladiator_Riot_Title";
                        msgText = "Gladiator_Riot_Text";
                        DisplayMessage(game);
                        nCommodus++;
                        nCommodusCheck = nTime + 240;
                    }
                    else if (nTime > 6000)
                        nCommodus = 9;
                    else
                        nCommodusCheck = nTime + 80;
                    break;

                case 8:
                    game.UnlockUIControl(mUIIDArena, Toolset.MainGameFormID);
                    game.UnlockUIControl(mUIIDGladiator, Toolset.MainGameFormID);
                    bArena = true;
                    nCommodusCheck = 6000;
                    break;

                case 9:
                    mID = IDMaker.FromString(sPatricians[8]);
                    game.GetActiveBuildings(mID, out num);
                    if (num == 0)
                    {
                        mID = IDMaker.FromString(sPatricians[9]);
                        game.GetActiveBuildings(mID, out num);
                    }
                    
                    if ((num > 0) && (nBeauty < 85))
                    {
                        game.TriggerFireDamage(mIDLibrary, (int)num, 90);
                        msgTitle = "Scholar_Riot_Title";
                        msgText = "Scholar_Riot_Text";
                        DisplayMessage(game);
                        nCommodus++;
                        nCommodusCheck = 96000;
                    }
                    else
                        nCommodusCheck = nTime + 80;
                    break;
                
                case 10:
                    break;

            }
        }

        /////////////////////////////////////////
        // Exploding sheep...
        void CheckSheep(IGameQueryInterface game)
        {
            uint num = 0;
            game.GetActiveBuildings(mIDSheepFarm, out num);
            if (num > nMaxSheep)
            {
                num = num - nMaxSheep;
                msgTitle = "Sheep_Kablooey_Title";
                msgText = "Sheep_Kablooey_Text";
                game.TriggerFireDamage(mIDSheepFarm, (int)num, 99);
                game.TriggerFireDamage(mIDSheepPasture, (int)(num * 2), 65);
            }
        }

        ////////////////////////////////////////////////////////////////////////////
        // Beauty rating is calculated every week
        // Current rating increases or decreases by 1 every week towards this value
        // Display every month, also every 2nd week if it changes
        void ShowBeautyRating(IGameQueryInterface game)
        {
            uint xBeauty = nBeauty;
            GetBeautyRating(game);
            if (uBeauty > nBeauty)
                nBeauty++;
            else if (uBeauty < nBeauty)
                nBeauty--;

            if (((nBeauty != xBeauty) && (nTime > nTwoWeeks)) || (nTime > nMonth))
            {
                msgWarn = "Beauty_Rating_" + nBeauty.ToString();
                game.SendWarningMessage(ref msgWarn, ref msgNoSound);
                bMessageSent = true;
            }
            if (nTime > nTwoWeeks) nTwoWeeks += 40;
            if (nTime > nMonth) nMonth += 80;
            if ((uBeauty < 100) && (nTime > nBeautyTip)) BeautyHint(game);
            CheckSheep(game);
        }

        ////////////////////////////////////////////////////////////////////////////////////
        // Controls Beauty Rating calculation - undesirable factor vs total desirable factor
        void GetBeautyRating(IGameQueryInterface game)
        {
            CountHomes(game);
            AddUndesirables(game);
            uUndes = Math.Max(uUndes, 100);
            uBeauty = 0;
            AddStatueBR(game);
            AddTHBScore(game);
            uDeco = uBeauty;
            AddGovBR(game);
            AddEntBR(game);
            AddRelBR(game);
            AddPatBR(game);
            AddOtherBR(game);
            if (uBeauty > 100) uBeauty = 100;
            nBeautyCheck += 20;
        }

        //////////////////////////////////////////////////////////////////////////////////
        // Counts the number of homes for 'coverage' purposes in calculating Beauty Rating
        void CountHomes(IGameQueryInterface game)
        {
            Int32 mID;
            uint num, nHomes = 0;
            string[] sHomes = {"C4b Plebian home 01", "C4b Plebian home 02", "C4b Plebian home 03",
                              "C4b Equites Housing 01", "C4b Equites Housing 02", "C4b Equites Housing 03"};

            for (int i = 0; i < 6; i++)
            {
                mID = IDMaker.FromString(sHomes[i]);
                game.GetTotalBuildings(mID, out num);
                nHomes += num;
            }
            for (int i = 0; i < 9; i++)
            {
                mID = IDMaker.FromString(sPatricians[i]);
                game.GetTotalBuildings(mID, out num);
                nHomes += num;
            }
            uUndes = nHomes * 2;
            nMaxSheep = 6 + (nHomes / 30);
        }

        ///////////////////////////////////////////////////////////////////////////////
        // Calculates the negative effect on Beauty rating from 'undesirable' buildings
        void AddUndesirables(IGameQueryInterface game)
        {
            AddUndesirable(game, mIDCattleFarm, 1);
            AddUndesirable(game, mIDSandCamp, 1);
            AddUndesirable(game, mIDIronMine, 1);
            AddUndesirable(game, mIDGoldMine, 1);
            AddUndesirable(game, mIDMarbleCamp, 1);
            AddUndesirable(game, mIDGranary, 1);
            AddUndesirable(game, mIDWarehouse, 1);
            AddUndesirable(game, mIDDepot, 1);
            AddUndesirable(game, mIDPort, 1);
            AddUndesirable(game, mIDGlass, 2);
            AddUndesirable(game, mIDJewelry, 1);
            AddUndesirable(game, mIDArmor, 2);
            AddUndesirable(game, mIDWeapons, 2);
            AddUndesirable(game, mIDArmory, 2);
            AddUndesirable(game, mIDMessHall, 2);
            AddUndesirable(game, mIDCavFort, 5);
            AddUndesirable(game, mIDDrillYard, 4);
        }

        /////////////////////////////////////////////////////////////////////
        // Adds the "undesirable" contribution for the specified building
        void AddUndesirable(IGameQueryInterface game, Int32 mID, uint iFactor)
        {
            uint num = 0;
            game.GetTotalBuildings(mID, out num);
            uUndes += iFactor * num;
        }

        ////////////////////////////////////////////////////////////
        // Beauty Rating from Government buildings
        void AddGovBR(IGameQueryInterface game)
        {
            uint num;
            uGovBR = nPalace(game);
            game.GetActiveBuildings(mIDBasilica, out num);
            if (num > 0) uGovBR += 3;
            uDes = uUndes / 2;
            AddWeightedBuild(game, mIDForum, 240, 3);
            uGovBR += uDes / uUndes;
            uBeauty += uGovBR;
        }

        ////////////////////////////////////////////////////////////
        // Beauty Rating from Temples & Shrines
        void AddRelBR(IGameQueryInterface game)
        {
            uDes = uUndes / 2;
            AddWeightedBuild(game, mIDJupiterTemple, 200, 2);
            AddWeightedBuild(game, mIDMarsTemple, 200, 2);
            AddWeightedBuild(game, mIDCeresTemple, 200, 2);
            AddWeightedBuild(game, mIDBacchusTemple, 200, 2);
            AddWeightedBuild(game, mIDMercuryTemple, 200, 2);
            AddFullBuild(game, mIDJupiterShrine, 40, 1);
            AddFullBuild(game, mIDMarsShrine, 40, 1);
            AddFullBuild(game, mIDCeresShrine, 40, 1);
            AddFullBuild(game, mIDBacchusShrine, 40, 1);
            AddFullBuild(game, mIDMercuryShrine, 40, 1);
            uRelBR = Math.Min((uDes / uUndes), 10);
            uBeauty += uRelBR;
        }

        //////////////////////////////////////////////
        // Beauty Rating from Entertainment buildings
        void AddEntBR(IGameQueryInterface game)
        {
            uint uMax, num;
            uDes = uUndes / 2;
            AddFullBuild(game, mIDOdeum, 160, 3);
            AddFullBuild(game, mIDActor, 160, 2);
            num = nDesVenue(game, mIDTheater, 0);
            uDes += Math.Min((num * 320), (uUndes * 4));
            uMax = uUndes * 3;
            num = nDesVenue(game, mIDArena, 1);
            uDes += Math.Min((num * 200), uMax);
            num = nDesVenue(game, mIDColiseum, 2);
            if (num > 0) uDes += uMax;
            num = nDesVenue(game, mIDCircus, 3);
            if (num > 0) uDes += uMax;
            
            uEntBR = Math.Min((uDes / uUndes), 16);
            uBeauty += uEntBR;
        }

        ////////////////////////////////////////
        // Beauty Rating from Patrician villas
        void AddPatBR(IGameQueryInterface game)
        {
            uint num;
            Int32 mID;
            uDes = uUndes / 2;
            for (int i = 0; i < 9; i++)
            {
                mID = IDMaker.FromString(sPatricians[i]);
                game.GetActiveBuildings(mID, out num);
                uDes += (uint)i * num * 20;
            }
            uPatBR = Math.Min((uDes / uUndes), 10);
            uBeauty += uPatBR;
        }

        ////////////////////////////////////////////////
        // Beauty Rating from other desirable buildings
        void AddOtherBR(IGameQueryInterface game)
        {
            uDes = uUndes / 2;
            AddFullBuild(game, mIDFountain, 160, 2);
            AddFullBuild(game, mIDLibrary, 320, 3);
            AddFullBuild(game, mIDBathhouse, 160, 3);
            AddWeightedBuild(game, mIDHospital, 120, 2);
            AddFullBuild(game, mIDExotic, 160, 1);
            AddFullBuild(game, mIDLuxury, 80, 1);
            uOtherBR = Math.Min((uDes / uUndes), 8);
            uBeauty += uOtherBR;
        }

        /////////////////////////////////////////////////////////////////
        // Venues are counted as inactive even if waiting for actors etc.
        // Allow venue to be inactive for 4 weeks before losing beauty
        uint nDesVenue(IGameQueryInterface game, Int32 mID, int iVenue)
        {
            uint num1, num2 = 0;
            game.GetActiveBuildings(mID, out num1);
            game.GetInactiveBuildings(mID, out num2);
            if ((num2 > 0) && (nTime < 7620))
            {
                if (bEmptyVenue[iVenue])
                    num2 = 0;
                else
                    bEmptyVenue[iVenue] = true;
            }
            else
                bEmptyVenue[iVenue] = false;

            return (num1 + num2);
        }

        ///////////////////////////////////////////////////////////////////
        // Add to 'desirable' score capped at uMax 
        void AddFullBuild(IGameQueryInterface game, Int32 mID, uint iFactor, uint uMax)
        {
            uint num;
            game.GetActiveBuildings(mID, out num);
            uDes += Math.Min((iFactor * num), (uMax * uUndes));
        }

        ////////////////////////////////////////////////////////////////////////
        // Beauty Rating where subsequent builds count less than the first
        void AddWeightedBuild(IGameQueryInterface game, Int32 mID, uint iFactor, uint uMax)
        {
            uint num;
            game.GetActiveBuildings(mID, out num);
            if (num > 0) num++;
            uDes += Math.Min((iFactor * num), (uMax * uUndes));
        }

        /////////////////////////////////////////////
        // Beauty Rating from Statues
        void AddStatueBR(IGameQueryInterface game)
        {
            uint num, numB;
            // small statues
            game.GetTotalBuildings(mIDStatue1, out num);
            numB = Math.Min((num / 8), 3);
            game.GetTotalBuildings(mIDStatue2, out num);
            numB += Math.Min((num / 8), 3);
            uSmallST = Math.Min(numB, 4);
            uBeauty += uSmallST;
            // medium statues + obelisk
            game.GetTotalBuildings(mIDStatue3, out num);
            numB = Math.Min((num / 4), 3);
            game.GetTotalBuildings(mIDStatue4, out num);
            numB += Math.Min((num / 4), 3);
            game.GetTotalBuildings(mIDObelisk, out num);
            if (num > 0) bMummy = true;
            numB += Math.Min(((num * 3 + 1) / 5), 6);
            uMediumST = Math.Min(numB, 10);
            uBeauty += uMediumST;
            // large statues
            game.GetTotalBuildings(mIDStatue5, out num);
            numB = Math.Min((num / 2), 5);
            game.GetTotalBuildings(mIDStatue6, out num);
            numB += Math.Min(((num * 5 + 1) / 6), 5);
            uLargeST = Math.Min(numB, 8);
            uBeauty += uLargeST;
        }

        ////////////////////////////////////////////
        // Beauty Rating from Trees, Hedges & Bushes
        void AddTHBScore(IGameQueryInterface game)
        {
            uint num1, num2, uMax;
            uDes = 0;
            AddFullBuild(game, mIDGarden, 40, 5);
            uGarden = uDes / uUndes;
            uDes = 0;
            AddFullBuild(game, mIDBushSmall, 20, 3);
            AddFullBuild(game, mIDBushLarge, 40, 5);
            uBush = uDes / uUndes;
            uDes = 0;
            AddFullBuild(game, mIDTreeSmall, 20, 3);
            AddFullBuild(game, mIDTreeMedium, 40, 5);
            uTree1 = uDes / uUndes;
            uDes = 0;
            AddFullBuild(game, mIDTreeLarge, 80, 7);
            uTree2 = uDes / uUndes;
            uMax = uUndes * 3;
            uDes = uUndes / 2;
            game.GetTotalBuildings(mIDHedgeLarge, out num1);
            game.GetTotalBuildings(mIDHedgeRowLarge, out num2);
            uDes += Math.Min(((num1 + num2) * 10), uMax);
            game.GetTotalBuildings(mIDHedgeSmall, out num1);
            game.GetTotalBuildings(mIDHedgeRowSmall, out num2);
            uDes += Math.Min(((num1 + num2) * 5), uMax); 
                          
            uTHB = Math.Min(((uDes / uUndes) + uBush + uTree1 + uTree2), 28);
            uBeauty += uTHB;
        }

        ////////////////////////////////////////
        // Beauty Rating hints from the Advisor
        void BeautyHint(IGameQueryInterface game)
        {
            int iEnd, iMax = 0;
            uint[] zBeauty = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
            String[] sHint = { "Tree1", "Tree2", "Garden", "Bush", "LargeST", "Statue", "GovBR", "EntBR", "PatBR", "RelBR", "OtherBR" };
            if (bTree)
            {
                zBeauty[0] = 8 - uTree1;
                zBeauty[1] = 7 - uTree2;
            }
            zBeauty[2] = 5 - uGarden;
            zBeauty[3] = 8 - uBush;
            if (bStatue3) zBeauty[4] = 8 - uLargeST;
            if (bStatue2)
                zBeauty[5] = 14 - (uSmallST + uMediumST);
            else if (bObelisk)
                zBeauty[5] = 10 - (uSmallST + uMediumST);
            else
                zBeauty[5] = 4 - uSmallST;
            zBeauty[6] = 11 - uGovBR;
            zBeauty[7] = 16 - uEntBR;
            zBeauty[8] = 10 - uPatBR;
            zBeauty[9] = 10 - uRelBR;
            zBeauty[10] = 8 - uOtherBR;

            if (uDeco < 45)
                iEnd = 6;
            else
                iEnd = 11;

            for (int i = 0; i < iEnd; i++)
            {
                if (zBeauty[i] > zBeauty[iMax]) iMax = i;
            }

            msgWarn = sHint[iMax] + "_Tip";

            DisplayWarning(game);
            nBeautyTip += 480;
        }

        ///////////////////////////////////////////////////////////////////
        // Enable patricians when conditions met: palace, security, beauty
        void CheckPatricians(IGameQueryInterface game)
        {
            if ((nPalace(game) > 0) && (nSecurity >= 24) && (nBeauty >= 24))
            {
                game.UnlockUIControl(mUIIDPatHome, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDExoticMarket, Toolset.MainGameFormID);
                msgWarn = "Patricians_Coming";
                DisplayWarning(game);
                bPatricians = true;
            }
            else if (nTime > nPatricianTip)
            {
                msgWarn = "Patricians_Tip";
                DisplayWarning(game);
                nPatricianTip = nTime + 480;
            }
        }
        
        ////////////////////////////////////////////////////////////////////////////
        // Adjust Pleb & Equite wage expectations each year treasury exceeds 10000dn
        void CheckWageExpectations(IGameQueryInterface game)
        {
            if (nCityFunds >= nWageTrigger)
            {
                nPlebWages += 2;
                nEquiteWages += 2;
                game.SetRomeStandardRate(true, nPlebWages);
                game.SetRomeStandardRate(false, nEquiteWages);
                // now advise player of raised expectations
                msgTitle = "Wage_Change_Title";
                msgText = "Wage_Change_Text";
                DisplayMessage(game);
            }
            nWageCheck = nTime + 960;           // next check in 12 months time
        }

        /////////////////////////////////////////////
        // Send message with applause to player
        void GiveAcclamation(IGameQueryInterface game)
        {
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgApplause);
            bMessageSent = true;
        }

        /////////////////////////////////////////////
        // Send basic message to player
        void DisplayMessage(IGameQueryInterface game)
        {
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgSound);
            bMessageSent = true;
        }

        /////////////////////////////////////////////
        // Send 'warning' to player
        void DisplayWarning(IGameQueryInterface game)
        {
            game.SendWarningMessage(ref msgWarn, ref msgSound);
            bMessageSent = true;
        }

        //////////////////////////////////////////
        // Send 'riot warning' to player
        void DisplayRiot(IGameQueryInterface game)
        {
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgRiot);
            bMessageSent = true;
        }

        /////////////////////////////////////////////////
        // Returns > 0 if palace built (1, 3 or 5) else 0
        private uint nPalace(IGameQueryInterface game)
        {
            UInt32 num = 0;
            game.GetActiveBuildings(mIDPalace3, out num);
            if (num > 0) return 5;
            game.GetActiveBuildings(mIDPalace2, out num);
            if (num > 0) return 3;
            game.GetActiveBuildings(mIDPalace1, out num);
            if (num > 0) return 1;
            return 0;
        }
        
        //////////////////////////////////////////////////////
        // return control panel buttons to their initial state
        private void ResetBaseUI(IGameQueryInterface game)
        {
            if (!bTheater)
            {
                game.LockUIControl(mUIIDTheater, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDActor, Toolset.MainGameFormID);
            }
            if (!bArena)
            {
                game.LockUIControl(mUIIDArena, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDGladiator, Toolset.MainGameFormID);
            }
            if (!bColiseum) game.LockUIControl(mUIIDColiseum, Toolset.MainGameFormID);
            if (!bCircus) game.LockUIControl(mUIIDCircus, Toolset.MainGameFormID);
            if (!bHospital) game.LockUIControl(mUIIDHospital, Toolset.MainGameFormID);
            if (!bBasilica) game.LockUIControl(mUIIDBasilica, Toolset.MainGameFormID);
            if (!bPatricians)
            {
                game.LockUIControl(mUIIDPatHome, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDExoticMarket, Toolset.MainGameFormID);
            }
            if (!bObelisk) game.LockUIControl(mUIIDObelisk, Toolset.MainGameFormID);
            if (!bTree)
            {
                game.LockUIControl(mUIIDSmallTree, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDMediumTree, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDLargeTree, Toolset.MainGameFormID);
            }
            if (!bStatue2)
            {
                game.LockUIControl(mUIIDHuntsman, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDHorseman, Toolset.MainGameFormID);
            }
            if (!bStatue3)
            {
                game.LockUIControl(mUIIDChariot, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDWinged, Toolset.MainGameFormID);
            }
            game.LockUIControl(mUIIDDepot0, Toolset.MainGameFormID);
            game.LockUIControl(mUIIDDepot1, Toolset.MainGameFormID);
            game.LockUIControl(mUIIDDepot2, Toolset.MainGameFormID);
            game.LockUIControl(mUIIDDepot3, Toolset.MainGameFormID);
            game.LockUIControl(mUIIDDepot4, Toolset.MainGameFormID);
            
        }

        void OnBeginScenario(IGameQueryInterface game)
        {
            mMilitaryAI = new TMilitaryAI(game);
            //
            // MILITARY REQUEST SETUP
            //
            sMilitaryRequestInfo requestInfo = new sMilitaryRequestInfo();
            MilitaryRequest request;

            // Conquest of Raider's site
            requestInfo.mRequestID = 5;
            requestInfo.mReward = 32;
            requestInfo.mPenalty = 0;
            requestInfo.mStartWeek = 24;
            requestInfo.mVariance = 0;
            requestInfo.mRecursionWeek = 0;
            requestInfo.mDeadline = 361;
            requestInfo.mFirstWarning = 240;
            requestInfo.mSecondWarning = 354;
            requestInfo.mTravelTime = 4;
            requestInfo.mWorldSiteIndex = 14;

            request = new MilitaryRequest();
            request.AddCohort(sCohortDbIDs.kParth_Cav, 2);
            request.AddCohort(sCohortDbIDs.kParth_Lt, 3);
            request.AddCohort(sCohortDbIDs.kParth_Aux, 2);
            request.AddMilitaryRequest(requestInfo, game);

            //
            // INVASION SETUP
            //
            mInvasions = new InvasionSetup[2];

            mInvasions[0] = new InvasionSetup("raid0", sInvasionFactions.kParthian,
                eInvasionType.kRaid, 1000, 144, 8);
            mInvasions[0].AddCohort(sCohortDbIDs.kParth_Aux, 1, 4, 4);
            mInvasions[0].AddCohort(sCohortDbIDs.kParth_Lt, 2, 4, 4);
            mInvasions[0].CreateInvasion(game, 0, 0);

            mInvasions[1] = new InvasionSetup("raid1", sInvasionFactions.kParthian,
                eInvasionType.kRaid, 2000, 216, 8);
            mInvasions[1].AddCohort(sCohortDbIDs.kParth_Cav, 1, 4, 4);
            mInvasions[1].AddCohort(sCohortDbIDs.kParth_Aux, 2, 4, 4);
            mInvasions[1].AddCohort(sCohortDbIDs.kParth_Lt, 2, 4, 4);
            mInvasions[1].CreateInvasion(game, 1, 72);

            // ensure the standard wage is set properly (only necessary on first load)
            mWageManagerPlebe = new StandardWageManager(game, eWageTypes.kPleb, 16);
            mWageManagerEques = new StandardWageManager(game, eWageTypes.kEques, 24);
            mWageManagerPlebe.SetGameWage(game);
            mWageManagerEques.SetGameWage(game);

            bInit = true;
            game.ScriptDone = false;
        }

        // Initialization needed on scenario load (when loading save games)
        void OnScenarioLoad(IGameQueryInterface game)
        {
            bInit = true;
            game.ScriptDone = false;
        }

        void OnInvasionArrival(IGameQueryInterface game)
        {
            foreach (InvasionSetup inv in mInvasions)
            {
                if (game.RunInvasion == inv.GetInvasionName())
                {
                    eInvasionType invType = inv.GetInvasionType();
                    mMilitaryAI.InvasionBegin(invType, game);
                    break;
                }
            }
        }

        void OnCohortTargetDestroyed(IGameQueryInterface game)
        {
            String nextOrders = mMilitaryAI.InvasionTargetDestroyed(game.RunCohortID, game);
            game.SetCohortOrders(game.RunCohortID, ref nextOrders);
        }
    }
}

